#include <cstdlib>
#include "argv.h"
#include "params.h"

#include <stdio.h>
#include "debug.h"

Argv::Argv()
{
    startlevel = 0;
    startlist = 0;
    startnlists = 0;
#ifdef FINALIZE
    cmp = 0;
    remaining = 0;
    part = 0;
    node = 0;
#endif
    persist = false;
    clamp = NULL;
}

unsigned int Argv::get_nlists(int level)const
{
    return  this->startnlists >> (level - this->startlevel);
}

unsigned int Argv::get_list0(int level, int rank)const
{
    // list0 at the beginning:
    INFO_DEBUG(VERBOSITY > 1, "NNODES: %u  startnlists: %u  rank: %u  NNODES/startnlists: %u   startlist: %u\n",
            NNODES, startnlists, rank, NNODES/startnlists, startlist);
    unsigned int ret = (rank / (1 << (NNODES/startnlists))) * 2 + startlist;
    // and on level level
    int i;
    for(i=startlevel;i<level;i++)
        ret >>= 1;
    return ret & (~1);
}

#ifdef FINALIZE
uint64_t Argv::get_cmp()
{
    return this->cmp;
}

uint64_t Argv::get_remaining()
{
    return this->remaining;
}

uint64_t Argv::get_part()
{
    return this->part;
}

uint64_t Argv::get_node()
{
    return this->node;
}
#endif

bool Argv::is_final_level(int level)
{
   return ((startnlists >> (level - this->startlevel)) == 1);
}

