#ifndef THREAD_H
#define THREAD_H

#include <pthread.h>

class Task;
class Tasks;

class Thread
{
    private:
        pthread_t thread; 
        Task *task;

        void *argv;

        friend void *thread_func(void* arg);

    public:
        Thread(Task *task);

        void start(void *argv);

        void join();
};

class ThreadGroup
{
    private:
        Thread **thread;
        int num_threads;

    public:
        ThreadGroup(Tasks *task);

        ~ThreadGroup();

        void start(void *argv);
        void join();
};

#endif

