
#define NET_DATA_SIZE 5242880 /* 5 MB */

class NetData
{
    private:
        uint8_t data[NET_DATA_SIZE];
        uint64_t offset;
        uint8_t listid;
        bool last_of_level;
    public:
        NetData()
        {
            this->offset = 0;
        }

        inline uint8_t *get_data()
        {
            return this->data;
        }

        inline uint8_t get_listid()
        {
            return listid;
        }

        inline bool is_empty()
        {
            return offset == 0;
        }

        template<typename T> inline uint64_t get_nelems()
        {
            return (offset / sizeof(T)); 
        }

        inline void set_last_of_level()
        {
            this->last_of_level = true;
        }

        inline bool is_last_of_level()
        {
            return this->last_of_level;
        }

        inline void reset(uint8_t listid)
        {
            this->offset = 0;
            this->listid = listid;
            this->last_of_level = false;
        }

        template<typename T> inline T* get_slot()
        {
            if(offset + sizeof(T) > NET_DATA_SIZE)
                return NULL;
            else
            {
                T* r;
                r = (T*)(this->data + this->offset);
                this->offset += sizeof(T);
                return r;
            }
        }
};
