#include "fsbday.h"
#include "task.h"

class Recv : public ScatterTask<NetData*>
{
    public:

        void run(void *argv, int tid)
        {
            MPI_Status s;
            int count;

            bool do_recv = true;

            NetData *net_data;

            INFO_DEBUG(VERBOSITY > 1, "thread %lu is recv\n", pthread_self());

            INFO_DEBUG(VERBOSITY > 1, "thread %u starting recv\n", tid);

            while (do_recv)
            {
                net_data = getSource()->get();

                MPI_Recv ((void *)net_data, sizeof(NetData), MPI_BYTE, 
                        tid, 0, MPI_COMM_WORLD, &s);

                INFO_DEBUG(VERBOSITY > 5, "recv: sender: %u\n", tid);

                MPI_Get_count(&s,MPI_BYTE,&count);

                if(count != 0)
                {
                    getSink()->getSink(net_data->get_listid() % 2)->put(net_data);
                }
                else
                {
                    getSource()->unget(net_data);

                    do_recv = false;
                }
            }

            INFO_DEBUG(1, "thread %u finished recv\n", tid);
        }

};
