#include "fsbday.h"
#include "task.h"

class Send : public PipelineTask<NetData*>
{

    void run(void *argv, int tid)
    {
        NetData *net_data;

        INFO_DEBUG(VERBOSITY > 1, "thread %lu is send\n", pthread_self());

        INFO_DEBUG(VERBOSITY > 1, "thread %u instance %p starting send\n", tid, this);

        while (running)
        {
            if (getSource()->get(&net_data, 1, 0))
            {
                INFO_DEBUG(VERBOSITY > 5, "Sending data to %u\n", tid);

                MPI_Send ((void *)net_data, sizeof(NetData), 
                        MPI_BYTE, tid, 0, MPI_COMM_WORLD);

                getSink()->put(net_data);
            }
        }

        INFO_DEBUG(1, "thread %u finished send\n", tid);
    } 
};


