#include <stdlib.h>
#include <memory.h>
#include <stdio.h>
#include <stdint.h>
#include <signal.h>
#include <execinfo.h>
#include <pthread.h>

static void signal_segv(int signum, siginfo_t* info, void*ptr)
{
    void *array[20];
    size_t size;
    size = backtrace(array, 20);

    fprintf(stderr, "Segmentation fault!\n");
    fprintf(stderr, "Signal: %i\n", signum);
    fprintf(stderr, "Thread: %lu\n", pthread_self());
    fprintf(stderr, "Stack trace:\n");

    backtrace_symbols_fd(array, size, 2);

    fprintf(stderr, "End of stack trace\n");

    raise(1); 
    exit(-1);
}

void setup_sigsegv()
{
    struct sigaction action;
    memset(&action, 0, sizeof(action));
    action.sa_sigaction = signal_segv;
    action.sa_flags = SA_SIGINFO;
    if(sigaction(SIGSEGV, &action, NULL) < 0)
    {
        perror("sigaction");
    }
}

