#ifndef TYPES_H
#define TYPES_H

#include "params.h"
#include "inttypes.h"
#include <sys/mman.h>

#define ALESIZE (512*13*9*5*5) /* DMA, level 2, level 3, level 0+1, (*5) to get close to 1.5 MB */
#define PARTSIZE (ALESIZE * 538) /* about 0.75 GB, must be integer multiple of ALESIZE */

typedef unsigned char ale_t[ALESIZE];
typedef unsigned char part_t[PARTSIZE];

class Part
{
    public:

    part_t *data;
    uint64_t nelems;

    Part()
    {
        data = (part_t*)mmap((void *) 0, sizeof(part_t),
                    PROT_READ | PROT_WRITE, MAP_PRIVATE | MAP_ANONYMOUS, (int) -1, (off_t) 0);
    }

    ~Part()
    {
            munmap(data, sizeof(part_t));
    }
};

class Ale
{
    public:
        ale_t *data;
        uint64_t nelems;
        uint32_t part;
        uint32_t list;

        bool is_last;

        Ale()
        {
            data = (ale_t*)mmap((void *) 0, sizeof(ale_t),
                    PROT_READ | PROT_WRITE, MAP_PRIVATE | MAP_ANONYMOUS, (int) -1, (off_t) 0);

            is_last = false;
        }

        ~Ale()
        {
            munmap(data, sizeof(ale_t));
        }
};

#endif
